Issue284

Title Better summary reports
Priority feature Status resolved
Superseder Nosy List ajaksu2, amk, brett.cannon, eric.araujo, ezio.melotti, loewis, techtonik
Assigned To ezio.melotti Topics

Created on 2009-05-09.23:28:29 by ajaksu2, last changed 2010-11-03.15:16:00 by ezio.melotti.

Files
File name Uploaded Type Edit Remove
roundup-summary.txt ajaksu2, 2009-05-09.23:28:28 text/plain
roundup-summary2 ezio.melotti, 2010-08-10.11:50:30 text/plain
roundup-summary2 ezio.melotti, 2010-08-10.13:10:18 text/plain
roundup-summary2 ezio.melotti, 2010-08-11.17:33:21 text/plain
roundup-summary2 ezio.melotti, 2010-08-12.14:31:24 text/plain
roundup-summary2 ezio.melotti, 2010-08-12.14:32:00 text/plain
roundup-summary2 ezio.melotti, 2010-08-12.15:26:16 text/plain
roundup-summary2 ezio.melotti, 2010-08-12.15:27:09 text/plain
roundup-summary2 ezio.melotti, 2010-08-12.15:34:38 text/plain
roundup-summary2.py ezio.melotti, 2010-07-30.05:19:16 text/plain
roundup-summary2.py ezio.melotti, 2010-08-01.03:14:56 text/plain
Messages
msg1395 (view) Author: ajaksu2 Date: 2009-05-09.23:28:27
The attached file is meant to (eventually) replace scripts/roundup-summary. It
is a major refactoring of the original, with less code, more documentation and
much more code organization.

Martin, can you run this against a real tracker and compare the output to the
original one? 

Its output should match that of he original script, except for a couple of
fixes: minor textual changes on the --help output, buglets (e.g. for audit
output) and whitespace normalization.

I want to add a couple of niceties to the reports, like a better summary of the
net change in open issues, report issues per priority and type, etc., but the
current script is way too confusing for me. 

Using a real templating engine (http://pythonpaste.org/tempita/ -> 730 LOC)
instead of rolling our own (as the current code does) could also be nice.
msg1720 (view) Author: ezio.melotti Date: 2010-07-04.06:29:11
I started working on this issue and tried to further improve roundup-summary.
It seems to me that the code could be simplified quite a lot if we removed the HTML reporting (o anyway part of it, since IMHO there are quite a lot of "YAGNI" features). Given that we don't use it and it's anyway quite ugly, can I remove it?
msg1721 (view) Author: techtonik Date: 2010-07-04.06:40:23
I don't use it, but properly formatted HTML notifications are looking
better (i.e. Google Calendar). You can use proportional fonts and
tables to align elements and insert short action links instead of full
URLs.
-- 
anatoly t.

On Sun, Jul 4, 2010 at 9:29 AM, Ezio Melotti
<metatracker@psf.upfronthosting.co.za> wrote:
>
> Ezio Melotti <ezio.melotti@gmail.com> added the comment:
>
> I started working on this issue and tried to further improve roundup-summary.
> It seems to me that the code could be simplified quite a lot if we removed the HTML reporting (o anyway part of it, since IMHO there are quite a lot of "YAGNI" features). Given that we don't use it and it's anyway quite ugly, can I remove it?
>
> ----------
> assignedto:  -> ezio.melotti
> nosy: +amk, ezio.melotti, loewis
> status: unread -> chatting
>
> _______________________________________________________
> PSF Meta Tracker <metatracker@psf.upfronthosting.co.za>
> <http://psf.upfronthosting.co.za/roundup/meta/issue284>
> _______________________________________________________
> _______________________________________________
> Tracker-discuss mailing list
> Tracker-discuss@python.org
> http://mail.python.org/mailman/listinfo/tracker-discuss
>
msg1722 (view) Author: ezio.melotti Date: 2010-07-04.06:59:57
AFAIK this script is only used to send the weekly reports to python-dev, and these have always been in plain text. Since I don't see any reason to switch to HTML and I think that most of the python-dev users prefer plain text anyway, I suggest to remove it to make the script easier to understand and more maintainable.
msg1723 (view) Author: brett.cannon Date: 2010-07-04.18:46:18
Python-dev would hate to get HTML emails, so that it is not a possibility.
msg1724 (view) Author: ezio.melotti Date: 2010-07-04.19:01:20
That's what I thought. It might still be useful to have HTML reports on some page on the site, but I don't know if anyone cares about having it and/or doing it.
Anyway I think I can preserver the HTML output after some refactoring.
msg1725 (view) Author: techtonik Date: 2010-07-04.20:22:57
If the script can be reused l8r for running personal notifications - that would be awesome.
msg1745 (view) Author: ezio.melotti Date: 2010-07-30.05:19:15
Attached there's the new roundup-summary script. The script is 30% shorter (650 loc vs. 920 of the original script) and hopefully easier to maintain and extend.
I preserved most of the original features -- including the HTML reports.
As is, the summary shows the number of open, closed and total issues and the delta with the previous period, e.g.:
Issues stats:
  open      16 ( +2)
  closed     5 ( +0)
  total     21 ( +2)

It then shows the number of open issues with patches and the following tables:
 * Issues opened during the last period
 * Issues closed during the last period
 * Top issues most discussed (the 10 most discussed issues of the last period)
 * Issues waiting for review (issues with patches, "needs review" keyword or "patch review" stage)

If the script is OK I'll commit it and then, after a few tests, it could be used to replace the old one.
msg1757 (view) Author: ezio.melotti Date: 2010-08-01.03:14:56
Here is an updated version.
Now there are 5 tables:
 * "Issues opened" lists all the issues opened or reopened in the last period that are still open.
 * "issues closed" lists all the issues closed in the last period that are still closed.
 * "Top issues most discussed" lists at most 10 open issues active in the last period sorted by number of messages.
 * "Recent issues without reply" lists the last 10 issues with no replies.
 * "Issues waiting for review" lists all the issues active in the last period with stage "patch review" or keywords "patch" or "needs review".
msg1772 (view) Author: ezio.melotti Date: 2010-08-10.11:50:29
Here is a new version. It's basically the same thing with a few tweaks.
msg1774 (view) Author: ezio.melotti Date: 2010-08-10.13:10:18
One more version, compatible with the Jython instance.
msg1782 (view) Author: ezio.melotti Date: 2010-08-11.17:33:21
Hopefully the final version, tweaked after the comments of RDM on Python-dev.
msg1784 (view) Author: ezio.melotti Date: 2010-08-12.15:54:04
Committed in r83963.
This also fix #189.
msg1798 (view) Author: techtonik Date: 2010-08-22.19:01:01
I could give you script a review if it was uploaded to http://codereview.appspot.com Otherwise it is hard to trace changes between all 10 versions.
msg1855 (view) Author: ezio.melotti Date: 2010-11-03.15:16:00
I changed the deltas at the top of the summary in #358.
History
Date User Action Args
2010-11-03 15:16:00ezio.melottisetstatus: chatting -> resolved
messages: + msg1855
2010-08-22 19:01:02techtoniksetstatus: resolved -> chatting
messages: + msg1798
2010-08-12 15:54:05ezio.melottisetstatus: testing -> resolved
messages: + msg1784
2010-08-12 15:34:38ezio.melottisetfiles: + roundup-summary2
2010-08-12 15:27:09ezio.melottisetfiles: + roundup-summary2
2010-08-12 15:26:16ezio.melottisetfiles: + roundup-summary2
2010-08-12 14:32:00ezio.melottisetfiles: + roundup-summary2
2010-08-12 14:31:24ezio.melottisetfiles: + roundup-summary2
2010-08-11 17:33:22ezio.melottisetfiles: + roundup-summary2
messages: + msg1782
2010-08-10 13:10:18ezio.melottisetfiles: + roundup-summary2
messages: + msg1774
2010-08-10 11:50:30ezio.melottisetfiles: + roundup-summary2
messages: + msg1772
2010-08-01 03:14:57ezio.melottisetfiles: + roundup-summary2.py
nosy: + eric.araujo
messages: + msg1757
2010-07-30 05:19:17ezio.melottisetstatus: chatting -> testing
files: + roundup-summary2.py
messages: + msg1745
2010-07-04 20:22:57techtoniksetmessages: + msg1725
2010-07-04 19:01:20ezio.melottisetmessages: + msg1724
2010-07-04 18:46:18brett.cannonsetnosy: + brett.cannon
messages: + msg1723
2010-07-04 06:59:57ezio.melottisetmessages: + msg1722
2010-07-04 06:40:24techtoniksetnosy: + techtonik
messages: + msg1721
2010-07-04 06:29:13ezio.melottisetstatus: unread -> chatting
nosy: + loewis, ezio.melotti, amk
messages: + msg1720
assignedto: ezio.melotti
2009-05-09 23:28:29ajaksu2create